"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.calculateFard = void 0;
const fardHeirs_1 = __importDefault(require("./fardHeirs"));
const result_1 = require("./result");
const utils_1 = require("./utils");
const quota_1 = require("./quota");
function calculateFard(heirs) {
    const fardHiers = fardHeirs_1.default.filter(fh => utils_1.exists(heirs, fh.name));
    const results = fardHiers
        .map(fh => {
        const result = {
            name: fh.name,
            count: utils_1.count(heirs, fh.name),
            type: 'fard',
            share: fh.share(heirs)
        };
        return result;
    })
        .filter(r => !utils_1.isZero(r.share));
    return shareSixthBetweenGrandmothers(results);
}
exports.calculateFard = calculateFard;
function shareSixthBetweenGrandmothers(results) {
    const mGrandMother = result_1.findFromResult(results, 'maternal_grand_mother');
    const pGrandMother = result_1.findFromResult(results, 'paternal_grand_mother');
    if (mGrandMother && pGrandMother) {
        return result_1.updateResults(results, utils_1.distribute([mGrandMother, pGrandMother], quota_1.sixth));
    }
    return results;
}
//# sourceMappingURL=fard.js.map