import Fraction from 'fraction.js';
declare type Spouse = 'husband' | 'wife';
declare type Descendant = 'son' | 'daughter' | 'paternal_grand_son' | 'paternal_grand_daughter';
declare type Ancestor = 'father' | 'mother' | 'paternal_grand_father' | 'paternal_grand_mother' | 'maternal_grand_mother';
declare type Sibling = 'full_brother' | 'full_sister' | 'paternal_sister' | 'paternal_brother' | 'maternal_sibling';
declare type Other = 'full_nephew' | 'paternal_nephew' | 'full_paternal_uncle' | 'paternal_paternal_uncle' | 'full_cousin' | 'paternal_cousin';
export declare type Heir = Spouse | Descendant | Ancestor | Sibling | Other;
export declare type Heirs = {
    [heir in Heir]: number;
};
export interface FardHeir {
    name: Heir;
    share: (heirs: Heirs) => Fraction;
}
export interface AsabaHeir {
    name: Heir;
    tasibRank: number;
}
export declare const heirs: Heirs;
export {};
