"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.calculate = exports.defaultHeirs = void 0;
const heir_1 = require("./heir");
Object.defineProperty(exports, "defaultHeirs", { enumerable: true, get: function () { return heir_1.heirs; } });
const fard_1 = require("./fard");
const tasib_1 = require("./tasib");
const specialCases_1 = require("./specialCases");
const calculate = (heirs) => {
    if (heirs.husband && heirs.wife) {
        throw Error('heirs cannot contain both husband and wife');
    }
    const allHeirs = Object.assign(Object.assign({}, heir_1.heirs), heirs);
    const fardResult = fard_1.calculateFard(allHeirs);
    const tasibResult = tasib_1.calculateTasib(allHeirs, fardResult);
    const results = specialCases_1.calculateSpecialCases(fardResult, tasibResult);
    return results;
};
exports.calculate = calculate;
//# sourceMappingURL=index.js.map