"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sumResults = exports.printResults = exports.updateResults = exports.findFromResult = exports.isTasib = exports.isFard = void 0;
const fraction_js_1 = __importDefault(require("fraction.js"));
const isFard = (result) => result.type === 'fard';
exports.isFard = isFard;
const isTasib = (result) => result.type === 'tasib';
exports.isTasib = isTasib;
const findFromResult = (results, heir, type) => {
    if (type)
        return results.find(r => r.name === heir && r.type === type);
    return results.find(r => r.name === heir);
};
exports.findFromResult = findFromResult;
const updateResults = (results, updateResults) => {
    return results.map(r => {
        const updated = exports.findFromResult(updateResults, r.name, r.type);
        return updated || r;
    });
};
exports.updateResults = updateResults;
function printResults(results) {
    const fractionToString = (r) => (Object.assign(Object.assign({}, r), { share: r.share.toFraction() }));
    console.log(results.map(fractionToString));
}
exports.printResults = printResults;
const sumResults = (results) => {
    let sum = new fraction_js_1.default(0);
    results.forEach(r => sum = sum.add(r.share));
    return sum;
};
exports.sumResults = sumResults;
//# sourceMappingURL=result.js.map